// Substituční princip B. Liskovové
/*
Čtverec je zvláštním případem obdélníka. Ovšem třída čtverec, odvozená od třídy
obdélník, je v některých případech rozlišitelná - nemůže zastoupit předka. Proto 
je použití děddění nesprávné.
*/
package liskov;

class Obdélník
{
    public Obdélník(double a, double b)
    {
        setA(a); 
        setB(b);
    }

    public double getA() {
        return a;
    }

    public void setA(double a) {
        this.a = a;
    }

    public double getB() {
        return b;
    }

    public void setB(double b) {
        this.b = b;
    }
    
    private double a;
    private double b;
    
}

class Čtverec extends Obdélník
{
    public Čtverec(double a)
    {
        super(a,a);
    }
    @Override
    public void setA(double a)  // Je třeba překrýt přístupové
    {                           // metody, a to je obvykle
        setB(a);                // příznakem, že je něco špatně
    }
    @Override
    public void setB(double b)
    {
        super.setA(b);
        super.setB(b);
    }
}

public class Program {

    private static void zpracuj(Obdélník obdélník) throws Exception
    {
        obdélník.setA(10);
        obdélník.setB(20);
        if(obdélník.getA() != 10)
            throw new Exception("Nejde nastavit šířku");
        System.out.println("Zpracovávám obdélník");
    }
    public static void main(String[] args) throws Exception 
    {
        Obdélník obdélník = new Obdélník(10, 11);
        zpracuj(obdélník);
        obdélník = new Čtverec(15);
        zpracuj(obdélník);
    }
    
}
